#include <iostream>
using namespace std;

#define MAX 50
int enfileirar(char fila[], int &ffila, char valor);
int desenfileirar(char fila[], int &ifila, int ffila, char &valor);
int empilhar(char pilha[], int &tpilha, char valor);
int desempilhar(char pilha[], int &tpilha, char &valor);

int main(void) {

    // Declarando uma fila e uma pilha
    char fila[MAX];
    int ifila = 0;
    int ffila = -1;
    char pilha[MAX];
    int tpilha = -1;

    char texto[MAX];
    char valor;
    int i;

    cout << "Digite um texto:" << endl;
    cin.getline(texto, MAX);
    // Enfileira todos
    for (i=0; texto[i]!='\0'; i++) enfileirar(fila, ffila, texto[i]);
    // Desenfileira um por um...
    while(desenfileirar(fila, ifila, ffila, valor)==0) {
        // Se for letra...
        if (isalpha(valor) !=0 ) {
            valor = valor & (255-32);
            empilhar(pilha, tpilha, valor);

        }
        else {
            empilhar(pilha, tpilha, valor);
        }
    }
    // Desempillha todos e imprime
    while(desempilhar(pilha, tpilha, valor)==0) {
        cout << valor << endl;
    }
}


// Retorna 0 em caso de sucesso e 1 em caso de fila cheia
int enfileirar(char fila[], int &ffila, char valor) {
    // Verificar se a fila est cheia
    if (ffila >= MAX-1) return 1;
    // Se no estiver
    // Incrementar a posio final
    ffila = ffila + 1;
    // Guardar o valor na posio final
    fila[ffila] = valor;
    // Indica sucesso
    return 0;
}

int desenfileirar(char fila[], int &ifila, int ffila, char &valor) {
    // Verificar se a fila t vazia (e retornar erro se sim)
    if (ffila < ifila) return 1;
    // Ler o elemento do inicio da fila
    valor = fila[ifila];
    // Atualizar o inicio da fila
    ifila = ifila + 1;
    // Retornar sucesso
    return 0;
}

// Retorna 0 em caso de sucesso e 1 em caso de pilha cheia
int empilhar(char pilha[], int &tpilha, char valor) {
    // Verificar se a pilha est cheia
    if (tpilha >= MAX-1) return 1;
    // Se no estiver
    // Incrementar o topo
    tpilha = tpilha + 1;
    // Guardar o valor na posio final
    pilha[tpilha] = valor;
    // Indica sucesso
    return 0;
}

// Retorna 0 em caso de sucesso e 1 em caso de pilha vazia
int desempilhar(char pilha[], int &tpilha, char &valor) {
    // Verificar se a pilha est cheia
    if (tpilha < 0) return 1;
    // Se no estiver
    // Recuperar valor
    valor = pilha[tpilha];
    // Decrementa o topo
    tpilha = tpilha - 1;
    // Indica sucesso
    return 0;
}
