#include <iostream>
using namespace std;

#define MAX 50

int enfileirar(int v[], int &fim, int valor);
int desenfileirar(int v[], int &ini, int fim, int &valor);

int main(void) {
    // Declara a fila
    int fila[MAX];
    int ini = 0;
    int fim = -1;

    // Varivel para armazenar dado digitado
    int dado;
    // Varivel que indica se acabaram valores da fila
    int vazia;

    // L valores e os enfileira, se forem >= 0
    do {
        cout << "Digite um numero inteiro positivo: ";
        cin >> dado;
        if (dado >=0) enfileirar(fila, fim, dado);
        } while(dado >= 0);

    // Agora mostra valores da pilha at que eles acabem...
    do {
        vazia = desenfileirar(fila, ini, fim, dado);
        if (vazia == 0) cout << dado << endl;
    } while (vazia == 0);
}

// Enfileira um valor
// Entrada:
//  v: vetor com elementos da fila
//  fim: fim da fila
//  valor: valor a ser enfileirado
// Retorna:
//  1- Se fila cheia
//  0- Caso contrrio
int enfileirar(int v[], int &fim, int valor) {
    // Se a fila est cheia... retorna 1
    if (fim>=MAX-1) {
        cout << "ERRO: Fila cheia!" << endl;
        return 1;
    }
    // Se fila no est cheia, vamos enfileirar
    fim = fim + 1;
    v[fim] = valor;
    // Indica que valor foi enfileirado
    return 0;
}


// Desenfileira um valor
// Entrada:
//  v: vetor com elementos da fila
//  ini: inicio da fila
//  fim: final da fila
//  valor: Local a colocar valor desenfileirado
// Retorna:
//  valor: valor desenfileirado
//  1- Se fila vazia
//  0- Caso contrrio
int desenfileirar(int v[], int &ini, int fim, int &valor) {
    // Se a fila est vazia... retorna 1
    if (fim < ini) {
        cout << "ERRO: Fila vazia!" << endl;
        return 1;
    }
    // Se fila no est vazia, vamos desenfileirar
    valor = v[ini];
    ini = ini + 1;
    // Indica que valor foi desenfileirado
    return 0;
}


